api/urls.py
from django.urls import path

from . import views

urlpatterns = [
	path('like', views.LikeView.as_view(), name='api_like'),
	path('dislike', views.DislikeView.as_view(), name='api_dislike'),
	path('subscribe', views.SubscribeView.as_view(), name='api_subscribe'),
	path('incrementviews', views.IncrementViewsView.as_view(), name='api_incrementviews'),
	path('videos', views.VideoUploadView.as_view(), name='api_video_upload'),
	path('videos/tickets', views.VideoTicketView.as_view(), name='api_video_tickets'),
	path('videos/edit/<watch_id>', views.VideoEditView.as_view(), name='api_video_edit'),
	path('videos/status/<watch_id>', views.VideoStatusView.as_view(), name='api_video_status'),
	path('videos/<channel_id>', views.VideoViewSet.as_view({'get' : 'list'}), name='api_videos_from_channel'),
	path('uploadavatar', views.UploadAvatarView.as_view(), name='api_upload_avatar'),
	path('comments/like', views.CommentLikeView.as_view(), name='api_comment_like'),
	path('comments/dislike', views.CommentDislikeView.as_view(), name='api_comment_dislike'),
	path('comments/tickets', views.CommentTicketView.as_view(), name='api_comment_tickets'),
	path('comments/<watch_id>', views.CommentView.as_view(), name='api_comments'),
	path('subscriptions', views.SubscriptionsView.as_view(), name='api_subscriptions'),
	path('notifications', views.NotificationsView.as_view(), name='api_notifications_unread'),
	path('admin/ban_user', views.BanUser.as_view(), name='api_ban_user'),
]

tracle/urls.py
import os

from django.contrib import admin
from django.urls import path, include
from django.conf import settings
from django.conf.urls.static import static

urlpatterns = [
    path('', include('web.urls')),
    path('api/', include('api.urls')),
]

urlpatterns += [path('admin/', admin.site.urls)]
urlpatterns += [path('django-rq/', include('django_rq.urls'))]

if settings.DEBUG:
    urlpatterns += static(settings.MEDIA_URL, document_root=settings.MEDIA_ROOT)
    try:
        import debug_toolbar
        urlpatterns += [path('__debug__/', include(debug_toolbar.urls))]
    except ImportError:
        pass

backend/forms.py
from django import forms
from django.contrib.auth.forms import ReadOnlyPasswordHashField, PasswordResetForm, _unicode_ci_compare
from django.contrib.auth.forms import SetPasswordForm as DjangoSetPasswordForm
from django.contrib.auth import get_user_model, authenticate
from .models import Video, Channel, ChannelBackground

from colorfield.fields import color_validator

User = get_user_model()
class UserAdminCreationForm(forms.ModelForm):
    """
    A form for creating new users. Includes all the required
    fields, plus a repeated password.
    """
    password1 = forms.CharField(label='Password', widget=forms.PasswordInput)
    password2 = forms.CharField(label='Password confirmation', widget=forms.PasswordInput)

    class Meta:
        model = User
        fields = ('email',)

    def clean_password2(self):
        # Check that the two password entries match
        password1 = self.cleaned_data.get("password1")
        password2 = self.cleaned_data.get("password2")
        if password1 and password2 and password1 != password2:
            raise forms.ValidationError("Passwords don't match")
        return password2

    def save(self, commit=True):
        # Save the provided password in hashed format
        user = super(UserAdminCreationForm, self).save(commit=False)
        user.set_password(self.cleaned_data["password1"])
        if commit:
            user.save()
        return user


class UserAdminChangeForm(forms.ModelForm):
    """A form for updating users. Includes all the fields on
    the user, but replaces the password field with admin's
    password hash display field.
    """
    password = ReadOnlyPasswordHashField()

    class Meta:
        model = User
        fields = ('email', 'password', 'email_confirmed', 'is_superuser', 'staff', 'banned')

    def clean_password(self):
        # Regardless of what the user provides, return the initial value.
        # This is done here, rather than on the field, because the
        # field does not have access to the initial value
        return self.initial["password"]


class SignupForm(forms.ModelForm):
    email = forms.EmailField(max_length=254, widget=forms.EmailInput(attrs={'placeholder' : 'E-MAIL'}))
    channel_name = forms.CharField(max_length=20, help_text='Required.', widget=forms.TextInput(attrs={'placeholder' : 'CHANNEL NAME'}))
    password1 = forms.CharField(widget=forms.PasswordInput(attrs={'placeholder' : 'PASSWORD'}))
    password2 = forms.CharField(label='Confirm password', widget=forms.PasswordInput(attrs={'placeholder' : 'CONFIRM PASSWORD'}))

    class Meta:
        model = User
        fields = ('email',)

    def clean_email(self):
        email = self.cleaned_data.get('email')
        qs = User.objects.filter(email=email)
        if qs.exists():
            raise forms.ValidationError("email is taken")
        return email

    def clean_password2(self):
        password1 = self.cleaned_data.get("password1")
        password2 = self.cleaned_data.get("password2")
        if password1 and password2 and password1 != password2:
            raise forms.ValidationError("Passwords don't match")
        return password2

    def save(self, request):
        user = super(SignupForm, self).save(commit=False)
        user.set_password(self.cleaned_data['password1'])
        user.save()
        channel = Channel.objects.create(name=self.cleaned_data.get('channel_name'), user=user)
        # Playlist.objects.create(title='History', channel=channel)
        return user

class SigninForm(forms.Form):
        
    email = forms.EmailField(max_length=254, widget=forms.EmailInput(attrs={'placeholder' : 'E-MAIL'}))
    password = forms.CharField(widget=forms.TextInput(attrs={'type' : 'password', 'placeholder' : 'PASSWORD'}))

    class Meta:
        model = User
        fields = ('email', 'password')

    def clean(self):
        email = self.cleaned_data.get('email')
        password = self.cleaned_data.get('password')

        if email is not None and password:
            user_cache = authenticate(username=email, password=password)
            if user_cache is None:
                raise forms.ValidationError('Invalid email or password.', code='invalid')
            if user_cache.banned:
                raise forms.ValidationError('Your account has been suspended. If you think you’ve been unjustifiably banned, please contact us. Your content will be deleted after 30 days', code='banned')
            if not user_cache.email_confirmed:
                raise forms.ValidationError('email address not confirmed.')
        return self.cleaned_data

class ResetPasswordForm(PasswordResetForm):
    def get_users(self, email):
        email_field_name = User.get_email_field_name()
        active_users = User._default_manager.filter(**{
            '%s__iexact' % email_field_name: email
        })
        return (
            u for u in active_users
            if u.has_usable_password() and
            _unicode_ci_compare(email, getattr(u, email_field_name))
        )

class SetPasswordForm(DjangoSetPasswordForm):
    new_password1 = forms.CharField(
        widget=forms.PasswordInput(attrs={'autocomplete': 'new-password', 'placeholder' : 'PASSWORD'}),
        strip=False,
    )
    new_password2 = forms.CharField(
        strip=False,
        widget=forms.PasswordInput(attrs={'autocomplete': 'new-password', 'placeholder' : 'CONFIRM PASSWORD'}),
    )

class ChangeUserForm(forms.Form):

    email = forms.EmailField(required=False, widget=forms.EmailInput(attrs={'disabled' : True}))
    channel_name = forms.CharField()
    description = forms.CharField(required=False, max_length=5000, widget=forms.Textarea())

    def save(self, instance):
        instance.name = self.cleaned_data['channel_name']
        instance.description = self.cleaned_data['description']
        instance.save()
        return instance

class ChangeAvatarForm(forms.ModelForm):
    class Meta:
        model = Channel
        fields = ('avatar',)

class VideoDetailsForm(forms.ModelForm):
    class Meta:
        model = Video
        fields = ('title', 'description', 'category', 'visibility')

class ChannelBackgroundForm(forms.ModelForm):
    avatar = forms.ImageField(widget=forms.FileInput(attrs={'style' : 'display: none'}), required=False)
    desktop_image = forms.ImageField(widget=forms.FileInput(attrs={'style' : 'display: none'}), required=False)
    color = forms.CharField(widget=forms.TextInput(attrs={'type' : 'color'}), validators=[color_validator], initial='#CCCCCC')
    desktop_image_repeat = forms.TypedChoiceField(empty_value=None, choices=ChannelBackground.RepeatChoices.choices)

    class Meta:
        model = ChannelBackground
        exclude = ['channel']

    def clean_desktop_image(self):
        f = self.cleaned_data.get('desktop_image')
        if f:
            f.name = f'bg.{f.name[-3:]}'
        return f

web/templates/web/base.html
{% load static %}
{% load compress %}
{% load notifications %}

<!doctype html>
<html class="no-js" lang="en">

<head>
  <meta charset="utf-8">
  {% block title %}
    <title>?</title>
  {% endblock %}
  <meta name="description" content="">
  <meta name="viewport" content="width=device-width, initial-scale=1">

  <link rel="apple-touch-icon" sizes="180x180" href="{% static 'web/img/apple-touch-icon.png' %}">
  <link rel="icon" type="image/png" sizes="32x32" href="{% static 'web/img/favicon-32x32.png' %}">
  <link rel="icon" type="image/png" sizes="16x16" href="{% static 'web/img/favicon-16x16.png' %}">
  <link rel="manifest" href="{% static 'web/img/site.webmanifest' %}">

  <script src="https://kit.fontawesome.com/f471545931.js" crossorigin="anonymous"></script>
  {% compress css %}
    <link rel="stylesheet" type="text/css" href="{% static 'web/css/normalize.css' %}">
    {% block css %}
    {% endblock %}
  {% endcompress %}

  <script async defer data-domain="tracle.tv" src="https://plausible.io/js/plausible.js"></script>
</head>

<body>
  <div id="nav-menu" class="nav__menu">
    <button id="nav-close" class="btn btn-gray" onclick="navMenuClose()"><i class="fas fa-times"></i></button>
    {% if request.user.is_authenticated %}
      <div class="nav__menu__head">
        <a href="/channel/{{ request.channel.channel_id }}"><img src="{% if request.channel.avatar %}{{ request.channel.avatar.url }}{% else %}{% static 'web/img/avatar.png' %}{% endif %}"></a>
        <div class="nav__menu__head__details">
          <a href="/channel/{{ request.channel.channel_id }}">{{ request.channel.name }}</a>
          <div>{{ request.user.email }}</div>
          <a href="{% url 'web_dashboard_settings' %}">Manage your Tracle Account</a>
        </div>
      </div>
      <a class="item" href="{% url 'web_channels' %}">Browse</a>
      <a class="item" href="{% url 'web_upload_video' %}">Upload</a>
      <a class="item" href="{% url 'web_signout' %}">Sign Out</a>
    {% else %}
      <a class="item" href="{% url 'web_signup' %}">Create Account</a>
      <a class="item" href="{% url 'web_signin' %}">Sign In</a>
    {% endif %}
  </div>
  {% block body %}
  {% endblock %}

  {% if request.user.is_authenticated %}
    {% csrf_token %}
    <script src="https://cdn.jsdelivr.net/npm/axios/dist/axios.min.js"></script>
    <script src="{% static 'web/js/notify.js' %}"></script>
    {% register_notify_callbacks callbacks='fill_notification_list,fill_notification_badge' %}
  {% endif %}

  {% compress js %}
    <script src="{% static 'web/js/vendor/jquery-3.4.1.min.js' %}"></script>
    <script src="{% static 'web/js/main.js' %}"></script>
  {% endcompress %}
  {% block script %}
  {% endblock %}
</body>

</html>

web/templates/web/channel_editor.html
{% extends 'web/base.html' %}
{% load static %}

{% block title %}
	<title>Channel Editor - Tracle</title>
{% endblock %}

{% block css %}
	<link rel="stylesheet" type="text/x-scss" href="{% static 'web/scss/channel_editor.scss' %}">
{% endblock css %}

{% block body %}
<div class="container">
    {% include 'web/includes/nav.html' %}
</div>
<div class="channel__settings">
    <div class="container channel__setttings__inner">
        <div class="channel__settings__inner__header">
            <h2>Channel Settings</h2>
            <div>
                <button id="btnCancel" class="btn btn-gray">Cancel</button>
                <button id="btnSubmit" class="btn btn-gray">Done Editing</button>
            </div>
        </div>
        <form id="settings_form" class="channel__settings__inner__form" method="POST" enctype="multipart/form-data" action="/channel_editor">
            {% csrf_token %}
            <button type="submit" disabled style="display: none" aria-hidden="true"></button>
            <div>
                <h3>Avatar</h3>
                <p>Preview your avatar below. To upload a new avatar, choose a new file.</p>
                <button id="btnAvatar" class="btn btn-gray" disabled>Select</button> <span>Use <a href="{% url 'web_dashboard_settings' %}">Account settings</a> for now</span>
                {{ form.avatar }}
                <h3>Background</h3>
                <p>Choose image. (<a href="{% static 'web/img/channel_template.png' %}" target="_blank">Official template</a>)</p>
                <button id="btnDesktopBg" class="btn btn-gray">Select</button> {{ form.desktop_image_repeat }}
                {% for error in form.desktop_image.errors %}
                    <p style="color: red;">{{ error }}</p>
                {% endfor %}
                {{ form.desktop_image }}
                <p>Background color</p>
                {{ form.color }}
                {% for error in form.color.errors %}
                    <p style="color: red;">{{ error }}</p>
                {% endfor %}
            </div>
            <div>
                <h3>Channel Banner</h3>
                <p>Banner height</p>
                <p>Push down where your channel starts to expose more of your background image. Note there are 22 additional pixels between the top of the banner and the top of the page.</p>
                {{ form.header_size }} 0 - 150px
                {% for error in form.header_size.errors %}
                    <p style="color: red;">{{ error }}</p>
                {% endfor %}
                <p>Enter image map code to make the top area of your background image clickable. Activate your code by entering a height greater than 0 above. Your image map will be 970 px wide by the height you specified.</p> 
                {{ form.imagemap }}
            </div>
        </form>
    </div>
</div>

<iframe src="/channel/{{ request.channel.channel_id }}" style="width: 100%; height: 100vh; border: none;"></iframe>

<div class="container">
    {% include 'web/includes/footer.html' %}
</div>
{% endblock body %}


{% block script %}
<script>
    window.onload = function () {
        var has_desktop_background = {% if request.channel.background and request.channel.background.desktop_image %} true {% else %} false {% endif %};
        var has_avatar_image = false;
        var preview_bg = document.getElementsByTagName('iframe')[0].contentWindow.document.getElementsByClassName('channel__container')[0];
        var preview_header = document.getElementsByTagName('iframe')[0].contentWindow.document.getElementById('user_banner');
        var preview_inner = document.getElementsByTagName('iframe')[0].contentWindow.document.getElementsByClassName('channel__container__inner')[0];

        var btnAvatar = document.getElementById('btnAvatar');
        var avatar_image_el = document.getElementById('id_avatar');
        btnAvatar.onclick = function (e) {
            e.preventDefault();
        }
        if (has_avatar_image) {
            btnAvatar.innerHTML = "Remove";
        }

        var desktop_image_el = document.getElementById('id_desktop_image');
        var btnDesktopBg = document.getElementById('btnDesktopBg');
        btnDesktopBg.onclick = function (e) {
            e.preventDefault();
            if (has_desktop_background) {
                var csrftoken = document.getElementsByName('csrfmiddlewaretoken')[0].value;
                var data = new FormData();
                data.append('delete', 'desktop_image');
                axios.post('/channel_editor', data, {headers: {'X-CSRFToken': csrftoken}})
                .then(response => {
                    desktop_image_el.value = '';
                    preview_bg.style.backgroundImage = 'unset';
                    has_desktop_background = false;
                    btnDesktopBg.innerHTML = "Select"
                    preview_inner.style.maxWidth = '1280px';
                });
            } else {
                desktop_image_el.click();
            }
        }
        if (has_desktop_background) {
            btnDesktopBg.innerHTML = 'Remove';
        }

        desktop_image_el.onchange = function () {
            const reader = new FileReader();
            reader.onload = function (e) {
                preview_bg.style.backgroundImage = 'url(' + e.target.result + ')';
                btnDesktopBg.innerHTML = 'Remove';
                has_desktop_background = true;
                preview_inner.style.maxWidth = '970px';
            }
            reader.readAsDataURL(this.files[0]);
        }

        var desktop_image_repeat_el = document.getElementById('id_desktop_image_repeat');
        desktop_image_repeat_el.onchange = function () {
            preview_bg.style.backgroundRepeat = this.selectedOptions[0].innerHTML;
        }

        var color_el = document.getElementById('id_color');
        color_el.oninput = function () {
            preview_bg.style.backgroundColor = this.value;
        }

        var header_el = document.getElementById('id_header_size');
        header_el.oninput = function () {
            preview_header.style.height = this.value + 'px';
        }
    }

    var btnCancel = document.getElementById('btnCancel');
    btnCancel.onclick = function () {
        document.location = '/channel/{{ request.channel.channel_id }}';
    }

    var btnSubmit = document.getElementById('btnSubmit');
    btnSubmit.onclick = function () {
        form = document.getElementById('settings_form');
        form.submit();
    }

</script>
{% endblock script %}
    

web/templates/web/channel_videos.html
{% extends 'web/channel_base.html' %}
{% load static %}
{% load compress %}
{% load humanize %}

{% block css %}
	<link rel="stylesheet" type="text/x-scss" href="{% static 'web/scss/channel_videos.scss' %}">
{% endblock %}

{% block channel_body %}
<div class="channel__body">
	<div class="channel__body__header">
		<h2>Uploads ({{ videos.count }})</h2>
		<div class="order-dropdown">
			<button class="btn btn-gray channel__body__header__button" onclick="toggleDropdown()">
				{% if ordering == 'da' %}
					Date added (newest - oldest)
				{% elif ordering == 'dd' %}
					Date add (oldest - newest)
				{% elif ordering == 'p' %}
					Most popular
				{% endif %}
			<i class="fas fa-caret-down"></i></button>
			<div id="ordermenu" class="order-dropdown-content">
				<a href="?sort=p">Most popular</a>
				<a href="?sort=da">Date added (newest - oldest)</a>
				<a href="?sort=dd">Date added (oldest - newest)</a>
			</div>
		</div>
		<script>
			function toggleDropdown() {
				content = document.getElementById('ordermenu');
				content.classList.toggle('open');
			}
		</script>
	</div>
	<div class="channel__body__sidebar">
		<div class="channel__body__sidebar__item selected">
			Uploaded Videos
		</div>
		<div class="channel__body__sidebar__item">
			<!-- Playlists -->
		</div>
	</div>
	<div class="channel__body__primary">
		<div class="feed__container">
			{% for video in videos %}
			<div class="feed__video">
				<a href="{% url 'web_watch' %}?v={{ video.watch_id }}"><img class="feed__video__thumbnail" src="{{ video.get_thumbnail }}"></a>
				<div class="feed__video__details">
					<a class="feed__video__details__title" href="{% url 'web_watch' %}?v={{ video.watch_id }}">{{ video.title }}</a>
					<span class="feed__video__details__views">{{ video.views }} views</span><span class="feed__video__details__timestamp">{{ video.created|naturaltime }}</span>
				</div>
			</div>
			{% endfor %}
		</div>
	</div>
</div>
{% endblock %}

web/templates/web/dashboard_account.html
{% extends 'web/dashboard_base.html' %}
{% load static %}
{% load compress %}

{% block css %}
	<link rel="stylesheet" type="text/x-scss" href="{% static 'web/scss/dashboard_account.scss' %}">
{% endblock css %}

{% block dashboard_body %}
	<div id="app">
		<div class="dashboard__body">
			<div class="dashboard__sidebar">
			</div>
			<div class="dashboard__primary">
				<h2 class="dashboard__title">Account settings</h2>
				<form method="post" enctype="multipart/form-data">
					{% csrf_token %}
					{% if form.subject.errors %}
						<ol>
						{% for error in form.subject.errors %}
							<li><strong>{{ error|escape }}</strong></li>
						{% endfor %}
						</ol>
					{% endif %}
					<p>
						<label for="id_email">E-Mail:</label><br/>
						{{ form.email }} {{ form.email.errors }}
					</p>
					<p>
						<label for="id_channel_name">Channel Name:</label><br/>
						{{ form.channel_name }} {{ form.channel_name.errros }}
					</p>
					<p>
						<label for="id_description">Description:</label><br/>
						{{ form.description }} {{ form.description.errors }}
					</p>
					<input class="btn btn-blue" type="submit" name="submit" value="Save">
				</form>
				<div class="thumb-container">
					<img :src="img">
					<button id="show-modal" class="btn btn-gray btn-crop-image" @click="showModal = !showModal">Edit</button>
				</div>
				<p><a href="{% url 'web_forgot_password' %}">Change password</a></p>
			</div>

		</div>
		<modal v-if="showModal" @close="showModal = false" v-bind:img="img"></modal>
	</div>
{% endblock %}

{% block script %}
<script src="https://cdn.jsdelivr.net/npm/axios/dist/axios.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/vue/dist/vue.js"></script>
<script src="https://unpkg.com/vue-advanced-cropper@0.17.2/dist/index.umd.js"></script>


<script type="text/javascript">
	Vue.component('modal', {
		delimiters: ['[[', ']]'],
		props: ['img'],
		methods: {
			uploadImage(event) {
				console.log('SAKDASKD');
				var input = event.target;
				if (input.files && input.files[0]) {
					var reader = new FileReader();
					reader.onload = (e) => {
						this.img = e.target.result;
					}
					reader.readAsDataURL(input.files[0]);
				}
			},
			save(event) {
				event.preventDefault();
				const {coordinates, canvas} = this.$refs.cropper.getResult();
				canvas.toBlob((blob) => {
					var csrftoken = document.getElementsByName('csrfmiddlewaretoken')[0].value;
					var data = new FormData();
					data.append('avatar', blob, '{{ channel.channel_id }}.png');
					axios.post('/api/uploadavatar', data, {headers: {'X-CSRFToken' : csrftoken, 'Content-Type': 'multipart/form-data'}}).then((response) => { this.$emit('close'); }, (error) => {console.log(error);});
				});
			},
			pixelsRestrictions({minWidth, minHeight, maxWidth, maxHeight, imageWidth, imageHeight}) {
				return {
					minWidth: minWidth,
					minHeight: minHeight,
					maxWidth: maxWidth,
					maxHeight: maxHeight
				}
			}
		},
		template: `
			<div class="modal-mask">
				<div class="modal-wrapper">
					<div class="modal-container">
						<h2>Change Profile Picture</h2>
						<cropper ref="cropper" :src="img" :stencil-props="{aspectRatio: 1}"></cropper>
						<form method="POST" enctype="multipart/form-data">
							<button class="btn btn-gray" @click="$emit('close')">Cancel</button>
							<span class="btn btn-gray btn-upload" @click="$refs.file.click()">
								<input id="file" name="avatar" type="file" ref="file" @change="uploadImage($event)" accept="image/*">
								Upload image
							</span>
							<button class="btn btn-blue" @click="save($event)">Save</button>
						</form>
					</div>
				</div>
			</div>
			`
	})

	var app = new Vue({
		delimiters: ['[[', ']]'],
		el: '#app',
		data: {
			img: '{% if channel.avatar %}{{ channel.avatar.url }}{% else %}/static/web/img/avatar.png{% endif %}',
			showModal: false
		}
	})
</script>
{% endblock %}

web/templates/web/email_confirm_account.html
{% autoescape off %}
Hi,

Please click on the link below to confirm your registration:

https://{{ domain }}{% url 'web_activate' key=uid token=token %}
{% endautoescape %}

web/templates/web/embed.html
<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Document</title>
</head>
<body>
<div>
    {% include 'web/includes/player.html' %}
</div>
</body>
</html>

web/templates/web/forgot_password_confirm.html
{% extends 'web/base.html' %}
{% load static %}
{% load compress %}

{% block title %}
	<title>Forgot Password - Tracle</title>
{% endblock %}

{% block css %}
	<link rel="stylesheet" type="text/x-scss" href="{% static 'web/scss/forgot_password.scss' %}">
{% endblock %}

{% block body %}
<div class="container">
	{% include 'web/includes/nav.html' %}
	<div class="form-container">
		{% if not validlink %}
			<h2>Something went wrong.</h2>
		{% else %}
			<p class="form-container__head">
				Please enter your new password twice so we can verify you typed it in correctly.
			</p>
			<form class="form-container__form" method="post">
				{% csrf_token %}
				{% for field in form %}
				  <p>
				    {{ field }}
				    {% for error in field.errors %}
				      <p style="color: red">{{ error }}</p>
				    {% endfor %}
				  </p>
				{% endfor %}
				<input class="btn btn-blue" type="submit" value="Submit">
			</form>
		{% endif %}
	</div>
</div>
{% endblock %}

web/templates/web/results.html
{% extends 'web/base.html' %}
{% load static %}
{% load compress %}
{% load humanize %}

{% block title %}
	<title>{{ search_terms }} - Tracle</title>
{% endblock %}

{% block css %}
	<link rel="stylesheet" type="text/x-scss" href="{% static 'web/scss/results.scss' %}">
{% endblock css %}

{% block body %}
<div class="container">
	{% include 'web/includes/nav.html' %}
	{% include 'web/includes/sidebar.html' %}

	<div class="primary">
		<div class="feed">
			<div class="feed__header">
				<h2>
					<i class="fas fa-search"></i> Results for: {{ search_terms }}
				</h2>
			</div>
			{% if not videos %}
				<p style="margin: 2em auto; text-align: center">We couldn't find any videos, sorry.</p>
			{% else %}
			<div class="feed__container">
				{% for video in videos %}
				<div class="feed__video">
					<a href="{% url 'web_watch' %}?v={{ video.watch_id }}"><img class="feed__video__thumbnail" src="{{ video.get_thumbnail }}"></a>
					<div class="feed__video__details">
						<h2 class="feed__video__details__title"><a href="{% url 'web_watch' %}?v={{ video.watch_id }}">{{ video.title }}</a></h2>
						<div class="feed__video__details__description">{{ video.description }}</div>
						<div class="feed__video__details__views">{{ video.views }} views</div>
						<a href="{% url 'web_channel' video.channel.channel_id %}" class="feed__video__details__channel">{{ video.channel.name }} </a>
						<div class="feed__video__details__timestamp">{{ video.created|naturaltime}}</div>
					</div>
				</div>
				{% endfor %}
			</div>
			{% endif %}
		</div>
	</div>
	{% include 'web/includes/footer.html' %}
</div>
{% endblock %}

web/templates/web/signup.html
{% extends 'web/base.html' %}
{% load static %}
{% load compress %}

{% block title %}
	<title>Sign Up - Tracle</title>
{% endblock %}

{% block css %}
	<link rel="stylesheet" type="text/x-scss" href="{% static 'web/scss/signup.scss' %}">
{% endblock %}

{% block body %}
<div class="container">
	{% include 'web/includes/nav.html' %}
	<div class="signup__container">
		<div class="signup__header">
			<h2>Sign up to Tracle!</h2>
			<p><strong>Get full access to Tracle with your account:</strong></p>
			<ul>
				<li>Upload and share your own videos with the world</li>
				<li>Comment on, rate, and make video responses to your favorite videos</li>
				<li>Build playlists of favorites to watch later</li>
			</ul>
		</div>
		<div class="signup__form">
			<h2>Sign Up</h2>
			<form method='post'>
				{% csrf_token %}
				{% for field in form %}
				  <p>
				    {{ field }}
				    {% for error in field.errors %}
				      <p style="color: red">{{ error }}</p>
				    {% endfor %}
				  </p>
				{% endfor %}
				<button class="btn btn-blue signup__form__button" type='submit'>Sign up</button>
				<span class="signup__form__signin">Already have an account? <a href="{% url 'web_signin' %}">Sign in</a></span>
			</form>
		</div>
	</div>
	{% include 'web/includes/footer.html' %}
</div>
{% endblock %}